#include <qapplication.h>
#include <qwidget.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qcombobox.h>
#include <qdial.h>
#include <qlcdnumber.h>
#include <qlabel.h>
#include <qlineedit.h>
#include "klasse.moc"


MeinWidget::MeinWidget (QWidget *parent=0, const char *name = 0)
  :  QWidget (parent, name)
{
  QVBox *vb = new QVBox (this);
  vb->setGeometry (10, 10, width () - 20, height () - 20);

  QHBox *hb1 = new QHBox (vb);
  QComboBox *cb = new QComboBox (hb1);
  cb->insertItem ("Hallo1");
  cb->insertItem ("Hallo2");
  connect (cb, SIGNAL (highlighted (const QString &)), 
    this, SLOT (combo_hl (const QString &)));

  QDial *dial = new QDial (hb1);
  connect (dial, SIGNAL (valueChanged (int)), 
    this, SLOT (dial_vc (int)) );

  lcd = new QLCDNumber (3, hb1);
  lcd->setMode (QLCDNumber::Hex);  

  QHBox *hb2 = new QHBox (vb);
  e = new QLineEdit ("QLineEdit", hb2);
  connect (e, SIGNAL (returnPressed ()),
    this, SLOT (edit_ret ()) );

  l = new QLabel ("QLineEdit", hb2);
}

void MeinWidget::combo_hl (const QString &s)
{
  l->setText (s);
}

void MeinWidget::dial_vc (int i)
{
  lcd->display (i);
}

void MeinWidget::edit_ret ()
{
  l->setText (e->text());
}


int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    MeinWidget *hallo = new MeinWidget;
    a.setMainWidget( hallo );
    hallo->setCaption ("Widgets in Massen");
    hallo->show();
    return a.exec();
}
