#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qpaintdevice.h>
#include <qpainter.h>
#include "klasse.moc"

Maus::Maus (double x, double y)
{
  xPos = (double) x;
  yPos = (double) y;
  NeuX = (double) x;
  NeuY = (double) y;
}

double Maus::getMausX (void)
{
  return xPos;
}

double Maus::getMausY (void)
{
  return yPos;
}

void Maus::calcNewPos (double OtherX, double OtherY)
{
  NeuX = xPos + 0.01 * (OtherX - xPos);
  NeuY = yPos + 0.01 * (OtherY - yPos);
}

void Maus::setNewPos (void)
{
  xPos = NeuX;
  yPos = NeuY;
}



MeinWidget::MeinWidget (QWidget *parent=0, const char*name = 0)
  : QWidget (parent, name)
{
  setMinimumSize (500, 500);
  setMaximumSize (500, 500);
  
  p = new QPushButton (this);
  p->setGeometry (width () - 20, height() - 20, 20, 20);
  connect (p, SIGNAL (clicked ()), this, SLOT (maus_update ()) );
  
  maeuse[0] = new Maus (10, 10);
  maeuse[1] = new Maus (width () - 20, 10);
  maeuse[2] = new Maus (width () - 20, height () - 20);
  maeuse[3] = new Maus (10, height () - 20);
  NumMaeuse = 4;
  maus_update ();
}

void MeinWidget::maus_update (void)
{
  int i, mn;
  
  // Neu zeichnen
  QPainter paint (this);
  paint.setPen (SolidLine);
  paint.moveTo (
    (int) maeuse[NumMaeuse-1]->getMausX (), 
    (int) maeuse[NumMaeuse-1]->getMausY ());
  for (i = 0; i < NumMaeuse; i++)
    {
      paint.lineTo (
        (int) maeuse[i]->getMausX (), 
        (int) maeuse[i]->getMausY ());
    }

  // Neue Positionen berechnen
  for (i = 0; i < NumMaeuse; i++)
    {
      mn = i+1;
      if (mn == NumMaeuse) mn = 0;
      maeuse[i]->calcNewPos (
        maeuse[mn]->getMausX (),
        maeuse[mn]->getMausY ());
    }

  // Neue Position aller Maeuse uebernehmen  
  for (i = 0; i < NumMaeuse; i++)
    maeuse[i]->setNewPos ();
}
    

int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    MeinWidget *hallo = new MeinWidget;
    a.setMainWidget( hallo );
    hallo->setCaption ("Ein Juengling liebte ein Maedchen...");
    hallo->show();
    return a.exec();
}
