#include <qapplication.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qmessagebox.h>
#include "klasse.moc"

MeinWidget::MeinWidget (QWidget *parent=0, const char*name = 0)
  : QWidget (parent, name)
{
  QPopupMenu *datei = new QPopupMenu (this);
  Q_CHECK_PTR (datei);
  // Abreissleiste im "Datei"-Menu
  datei->insertTearOffHandle ();
  datei->insertItem ( "&Exit", this, SLOT (s_exit ()), CTRL+Key_E );
  datei->insertItem ( "En&de, sofort!", qApp, SLOT (quit ()), CTRL+Key_Q );

  QPopupMenu *submenu = new QPopupMenu (this);
  Q_CHECK_PTR (submenu);
  submenu->insertItem ( "Sub&1", this, SLOT (s_empty ()) );
  submenu->insertSeparator ();
  submenu->insertItem ( "Sub&2", this, SLOT (s_empty ()) );

  QPopupMenu *menu = new QPopupMenu (this);
  Q_CHECK_PTR (menu);
  menu->insertItem ( "Menu&1", this, SLOT (s_empty ()) );
  menu->insertItem ( "Sub", submenu);
  menu->insertItem ( "Menu&2", this, SLOT (s_empty ()) );

  mbar = new QMenuBar (this);
  Q_CHECK_PTR (mbar);
  mbar->insertItem ("&Datei", datei);
  mbar->insertItem ("&Menu", menu);
}


void MeinWidget::s_exit (void)
{
  switch (
    QMessageBox::critical (this, "Anwendung beenden",
      "Nicht gespeicherte Daten gehen verloren.\n\tWirklich Beenden?",
      QMessageBox::Cancel, QMessageBox::No))
    {
      case QMessageBox::Cancel:
            QMessageBox::information(
              this,
              "Rumdrueckerei!",
              "Sie haben auf \"Cancel\" gedrueckt!",
              "Ich weiss!", "Mir doch egal!");
            break;
      case QMessageBox::No:
            QMessageBox::information(
              this, 
              "Rumdrueckerei!",
              "Sie haben auf \"No\" gedrueckt!",
              "Na und?");
            break;
    }
}


void MeinWidget::s_empty (void)
{
  if (mbar->isDefaultUp ())
    mbar->setDefaultUp (FALSE);
  else
    mbar->setDefaultUp (TRUE);
}


int main( int argc, char **argv )
{
    QApplication a( argc, argv );
    MeinWidget *hallo = new MeinWidget;
    a.setMainWidget( hallo );
    hallo->setCaption ("Menues a la carte");
    hallo->show();
    return a.exec();
}
